This is the mail archive of the libc-alpha@sources.redhat.com mailing list for the glibc project.


Index Nav: [Date Index] [Subject Index] [Author Index] [Thread Index]
Message Nav: [Date Prev] [Date Next] [Thread Prev] [Thread Next]
Other format: [Raw text]

Re: [Patch] ldd failures on multilb architectures


Jakub Jelinek wrote:
On Fri, Nov 14, 2003 at 10:48:32AM +0100, Hannes Reinecke wrote:

Hi all,

/usr/bin/ldd has some slight problems with multilib architectures. First, it tries to execute all eligible 'ld.so', but does not redirect the output to /dev/null, so we always get the nasty 'Cannot execute binary file' error message.


Who issues this error message? Works just fine for me in current CVS
(and several months old glibc too).
Say on s390x (looking at your signature):
echo 'int main () { return 0; }' > test.c
for i in -m31 -m64; do for j in "" -static; do gcc $i $j -o test test.c; ldd ./test; echo $?; done; done
        libc.so.6 => /lib/libc.so.6 (0x4002d000)
        /lib/ld.so.1 => /lib/ld.so.1 (0x40000000)
0
        not a dynamic executable
1
        libc.so.6 => /lib64/tls/libc.so.6 (0x0000010000031000)
        /lib64/ld64.so.1 => /lib64/ld64.so.1 (0x0000010000000000)
0
        not a dynamic executable
1

which is the expected output.

It says here (disregarding 31bit, since the installation appears to be broken on my machine):

hare> gcc -m64 -o test test.c
hare> ldd ./test
/usr/bin/ldd: line 1: /lib/ld.so.1: cannot execute binary file
        libc.so.6 => /lib64/libc.so.6 (0x0000010000025000)
        /lib/ld64.so.1 => /lib/ld64.so.1 (0x0000010000000000)
hare> gcc -m64 -static -o test test.c
hare> ldd ./test
/usr/bin/ldd: line 1: /lib/ld.so.1: cannot execute binary file
/usr/bin/ldd: line 1: /lib/ld.so.1: cannot execute binary file
ldd: /lib/ld.so.1 exited with unknown exit code (126)
hare> gcc --version
gcc (GCC) 3.3.2 (SuSE Linux)
Copyright (C) 2003 Free Software Foundation, Inc.
This is free software; see the source for copying conditions.  There is NO
warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

hare> ldd --version
ldd (GNU libc) 2.3.2
Copyright (C) 2003 Free Software Foundation, Inc.
This is free software; see the source for copying conditions.  There is NO
warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
Written by Roland McGrath and Ulrich Drepper.


Second, 'ld.so' might return 1 in case it found a statically linked binary. Since ldd only checks for return codes 0 or 2, it fails horribly.


And this second change is clearly broken.
ld.so will exit with 1 if any error happens, e.g. incompatible object
or statically linked object.  If you break for 1, you just killed multi-lib
ldd.

Hmm. See output above. I'd be very surprised if this is the expected output. I've attached the ldd script for reference.

Cheers,

Hannes
--
Dr. Hannes Reinecke			hare@suse.de
SuSE Linux AG				S390 & zSeries
Deutschherrnstr. 15-19			+49 911 74053 688
90429 Nürnberg				http://www.suse.de
#! /bin/sh
# Copyright (C) 1996-2001, 2002, 2003 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.


# This is the `ldd' command, which lists what shared libraries are
# used by given dynamically-linked executables.  It works by invoking the
# run-time dynamic linker as a command and setting the environment
# variable LD_TRACE_LOADED_OBJECTS to a non-empty value.

# We should be able to find the translation right at the beginning.
TEXTDOMAIN=libc
TEXTDOMAINDIR=/usr/share/locale

RTLDLIST=/lib/ld-linux.so.2
warn=
bind_now=
verbose=

while test $# -gt 0; do
  case "$1" in
  --vers | --versi | --versio | --version)
    echo 'ldd (GNU libc) 2.3.2'
    echo $"Copyright (C) 2003 Free Software Foundation, Inc.
This is free software; see the source for copying conditions.  There is NO
warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
Written by Roland McGrath and Ulrich Drepper."
    exit 0
    ;;
  --h | --he | --hel | --help)
    echo $"Usage: ldd [OPTION]... FILE...
      --help              print this help and exit
      --version           print version information and exit
  -d, --data-relocs       process data relocations
  -r, --function-relocs   process data and function relocations
  -v, --verbose           print all information
Report bugs using the \`glibcbug' script to <bugs@gnu.org>."
    exit 0
    ;;
  -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
  --data-rel | --data-relo | --data-reloc | --data-relocs)
    warn=yes
    shift
    ;;
  -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
  --function | --function- | --function-r | --function-re | --function-rel | \
  --function-relo | --function-reloc | --function-relocs)
    warn=yes
    bind_now=yes
    shift
    ;;
  -v | --verb | --verbo | --verbos | --verbose)
    verbose=yes
    shift
    ;;
  --v | --ve | --ver)
    echo >&2 $"ldd: option \`$1' is ambiguous"
    exit 1
    ;;
  --)		# Stop option processing.
    shift; break
    ;;
  -*)
    echo >&2 'ldd:' $"unrecognized option" "\`$1'"
    echo >&2 $"Try \`ldd --help' for more information."
    exit 1
    ;;
  *)
    break
    ;;
  esac
done

nonelf ()
{
  # Maybe extra code for non-ELF binaries.
  file=$1
  # Run the ldd stub.
  lddlibc4 "$file"
  # Test the result.
  if test $? -lt 3; then
    return 0;
  fi
  # In case of an error punt.
  return 1;
}

add_env="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"
add_env="$add_env LD_LIBRARY_VERSION=\$verify_out"
add_env="$add_env LD_VERBOSE=$verbose"
case $# in
0)
  echo >&2 'ldd:' $"missing file arguments"
  echo >&2 $"Try \`ldd --help' for more information."
  exit 1
  ;;
1)
  single_file=t
  ;;
*)
  single_file=f
  ;;
esac

result=0
for file do
  # We don't list the file name when there is only one.
  test $single_file = t || echo "${file}:"
  case $file in
  */*) :
       ;;
  *) file=./$file
     ;;
  esac
  if test ! -f "$file"; then
    echo "ldd: ${file}:" $"No such file or directory" >&2
    result=1
  elif test -r "$file"; then
    test -x "$file" || echo 'ldd:' $"\
warning: you do not have execution permission for" "\`$file'" >&2
    RTLD=
    for rtld in ${RTLDLIST}; do
      if test -x $rtld; then
	verify_out=`${rtld} --verify "$file"`
        ret=$?
	case $ret in
	[02]) RTLD=${rtld}; break;;
	esac
      fi
    done
    if test -z "${RTLD}"; then
      set ${RTLDLIST}
      RTLD=$1
      verify_out=`${RTLD} --verify "$file"`
      ret=$?
    fi
    case $ret in
    0)
      eval $add_env '"$file"' || result=1
      ;;
    1)
      # This can be a non-ELF binary or no binary at all.
      nonelf "$file" || {
	echo $"	not a dynamic executable"
	result=1
      }
      ;;
    2)
      eval $add_env \${RTLD} '"$file"' || result=1
      ;;
    *)
      echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($ret)" >&2
      exit 1
      ;;
    esac
  else
    echo 'ldd:' $"error: you do not have read permission for" "\`$file'" >&2
    result=1
  fi
done

exit $result
# Local Variables:
#  mode:ksh
# End:

Index Nav: [Date Index] [Subject Index] [Author Index] [Thread Index]
Message Nav: [Date Prev] [Date Next] [Thread Prev] [Thread Next]